/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package stats;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Peter
 */

class doWork implements Runnable {
    private int idNumber;
    public doWork(int idNumber) {
        this.idNumber = idNumber;
    }
    
    public void run() {
        System.out.println("worktask: " + idNumber);
        
        try {
            Thread.sleep(1000);
        } catch (InterruptedException ex) {
            Logger.getLogger(doWork.class.getName()).log(Level.SEVERE, null, ex);
        }
        System.out.println("completed task: " + idNumber);
    }
}

public class Stats {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        int numberOfCPUs;
        numberOfCPUs = Runtime.getRuntime().availableProcessors();
        int numberOfThreads = (int) (numberOfCPUs * 0.8 * (2)); // see ThreadPoolAccountant.java
        System.out.println("We're creating: " + numberOfThreads + "threads\n");
        ThreadPoolExecutor executor = new ThreadPoolAccountant(numberOfThreads, numberOfThreads, 10, TimeUnit.SECONDS, new LinkedBlockingQueue<Runnable>(10000));        
        //let's use the executor service to do stuff
        for(int task = 0; task < numberOfThreads; task++) {
            executor.submit(new doWork(task));
        }
        //ok work tasks have been submitted
        //let's shutdown gracefully: no new work, but let the threads finish.
        executor.shutdown();
        try {
            //nothing to do now, but wait, kinda like what join() would do.
            executor.awaitTermination(10, TimeUnit.SECONDS);
        } catch (InterruptedException ex) {
            System.out.println("Interrupted execption awaiting thread termination in main() ");
        }
    }
    
}
